<?php

namespace Cronard;

trait CronardTrait {

    public array $crontabs = [];

    public function launch(array $variables) : void
    {
        $cronard = new Cronard();

        foreach($this->crontabs as $tab => $callback) {
            $cronard->setTab($tab);
            $cronard->run(array_merge($this->variables, $variables), $callback);
        }
    }

    public function fromFile(string $filepath) : self
    {
        if ( ! file_exists($filepath) ) {
            throw new \RuntimeException("Given crontab file cannot be found. There could also be a problem at permission level.");
        }

        $this->crontabs = include($filepath);
        
        return $this;
    }
}
